;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Rotinas de SOM do Muffie;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LATCH:			EQU $C000		; tenho que gravar a porra do ultimo latch...
FREQLOW:		EQU $C001		; PARTE BAIXA DO SOM
FLAGNOISE:		EQU $C002	; PARA QUANDO O COLECO COLOCA O NOISE CHUPINHANDO CANAL 2
VOLUMEC:		EQU $C003		; TENHO QUE GUARDAR O VOLUME DO CANAL C

INIT_SOUND:
	PUSH AF
	LD	A,7
	OUT	($A0),A
	LD A,%10111000	; sem ruido
	OUT ($A1),A
	
	LD A,8
	OUT	($A0),A	; Selecionei registrador 8, volume do canal A , carregado no a  do PSG
	LD A,%00000000 ;  Modo Fixo, volume ZERO
	OUT ($A1),A	; gravei

	LD A,9
	OUT	($A0),A	; Selecionei registrador 9, volume do canal B , carregado no a  do PSG
	LD A,%00000000 ;  Modo Fixo, volume ZERO
	OUT ($A1),A	; gravei

	LD A,10
	OUT	($A0),A	; Selecionei registrador 10, volume do canal c , carregado no a  do PSG
	LD A,%00000000 ;  Modo Fixo, volume ZERO
	OUT ($A1),A	; gravei

	POP AF
	RET
; -----------------------------------------------------------------------
TOCA_SOM_COLECO:
	PUSH AF
	PUSH BC
	PUSH HL
	PUSH DE
		
	LD B,A			; 
	BIT 7,A
	JR Z,TS_DADOS

TS_REGISTRO:
	LD (LATCH),A
	AND %00010000				; SE DER ZERO  FREQUENCIA
	JR Z,TS_FREQUENCIA
TS_VOLUME:						; SENO  VOLUME...
	LD A,B
	AND %01100000
	RRCA
	RRCA
	RRCA
	RRCA
	RRCA						; NMEROS BONITINHOS: 0 = CANAL 0, 1 = CANAL 1, 2 = CANAL 2 E 3=CANAL RUIDO!
	LD C,A						; C TEM O CANAL
	LD A,B
	AND %00001111
	CPL
	AND %00001111				; VOLUME NO COLECO EH INVERTIDO
	LD B,A						; B AGORA TEM O VOLUME CERTINHO	
	LD A,C
	CP  %00000011				; SER QUE ELE QUER O VOLUME DO RUIDO?
	JR Z,TS_VOLUME_RUIDO	
	LD A,8
	ADD A,C						; PARA PEGAR O REGISTRADOR CERTO PARA O VOLUME DE CADA CANAL
	OUT ($A0),A
	LD A,B	
	OUT ($A1),A					; PRONTO, VOLUME "SETADO"
	JR TS_FIM
TS_VOLUME_RUIDO:
	LD A,B
	LD (VOLUMEC),A				; SALVEI O VOLUME DO RUIDO
	JR TS_FIM					;
	
TS_FREQUENCIA:
	LD A,B						; O B AQUI AINDA TEM O LATCH FULL
	AND %01100000				; SER QUE ELE QUER RUIDO?
	CP  %01100000
	JR Z,TS_FREQ_RUIDO
	LD A,B
	AND %00001111				; SEPAREI OS BITS DA PARTE DE BAIXO DA FREQUENCIA
	LD (FREQLOW),A					; ACABO DE GRAVAR NA "MINI-RAM" DO EMULADOR DE SOM...
	JR TS_FIM

TS_FREQ_RUIDO:
	LD A,B
	AND %00000011
	CP  %00000011
	JR Z,TS_SETA_FLAG
	LD A,%00000000
	LD (FLAGNOISE),A	; DESLIGA FLAG
	JR TS_FIM
TS_SETA_FLAG:
	LD A,%10000000
	LD (FLAGNOISE),A	; LIGA FLAG
	JR TS_FIM					

TS_FIM:
	POP DE
	POP HL
	POP BC
	POP AF
	RET

	
TS_DADOS:
	AND %00111111
	RLCA
	RLCA
	RLCA
	RLCA
	AND %11110000
	LD HL,FREQLOW
	LD C,(HL)
	ADD A,C							; 8 PRIMEIROS BITS DA FREQUENCIA ESTAO EM A
;	RLCA							; MULTIPLIQUEI POR 2
	
	LD C,A							; B TEM O LATCH ORIGINAL (DADOS) E C TEM OS 8 BITS DA FREQUENCIA DO TOM
	LD A,(LATCH)		; 
	AND %01100000
	RRCA
	RRCA
	RRCA
	RRCA
	LD D,A							; BEM, AGORA D TEM O CANAL * 2, OU SEJA 0=0, 1=2 E 2=4 (REGISTRADORES)
		
	OUT ($A0),A						; 0 OU 2 OU 4
	LD A,C
	OUT ($A1),A						; GRAVEI, AGORA LIBEREI O C
	INC D							; D JAH APONTA PARA O REGISTRO DOS  BITS MAIS SIGNIFICATIVOS DA FREQUENCIA: 1, 3 OU 4
	LD A,B
	LD B,C							; AT AQUI: B = 8 BITS MENOS SIGNIFICATIVOS, C = LIVRE, D = REGISTRADORES DOS BITS MAIS SIGNIFICATIVOS
	AND %00111111
	RRCA
	RRCA
	RRCA
	RRCA
	AND %00000111
	LD C,A
	LD A,D
	OUT ($A0),A
	LD A,C
	OUT ($A1),A						; PRONTO, REG 1,3 OU 4 JAH TEM A PARTE MAIS SIGNIFICATIVOS.
	
	LD A,(FLAGNOISE)
	DEC D							; D TEM DE NOVO O CANAL * 2 (00,01 OU 10)
	ADD A,D
	CP %10000100					; 1o BIT INDICA O FLAG, O 10 NO FINAL INDICA O CANAL 2
	JR NZ,TS_FIM					; SE NO FOR, NO FAO MAIS NADA...
	
	; RUIDO SIMULADO NO TOM MESMO...
	; EM TEORIA BASTA SETAR O VOLUME DO CANAL CORRETO AGORA
	LD A,(VOLUMEC)
	CP %00000000					; se o ruido do C for zero, basta ignorar.
	JR Z,TS_FIM						; seno, o cara ta tentando fazer ruido...
	LD B,A
	LD A,10
	OUT ($A0),A
	LD A,B
	OUT ($A1),A
									; agora vamos engrossar o som
	LD A,5
	OUT ($A0),A
	IN A,($A2)
	LD B,A
	AND %10000000
	RRCA
	RRCA
	RRCA
	RRCA
	RRCA
	RRCA
	RRCA
	LD C,A
	LD A,B
	RLCA
	OUT ($A1),A						; PARTE BAIXA ENGROSSADA
	LD A,6
	OUT ($A0),A
	IN A,($A2)
	RLCA
	ADD A,C
	AND %00001111
	OUT ($A1),A						; SER QUE VAI FERRAR TUDO??
	JR TS_FIM